> For the complete documentation index, see [llms.txt](https://docs.squads.so/squads-v3-docs/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.squads.so/squads-v3-docs/development/anchor-idl/transactions/create-a-transaction.md).

# Create a Transaction

To create a transaction for the multisig to act upon first derive a PDA for the transaction. The transaction PDA is used to reference the account created, and will store some basic information about the transaction.

In addition to the PDA, creating a transaction also requires and authority index.

A complete example to create a new Transaction with the expected `transactionIndex`

<pre><code><strong>// fetch the multisig
</strong><strong>const multisigAccount = await squadsProgram.account.ms.fetch(multisig);
</strong><strong>
</strong><strong>// get the next expected transactionIndex
</strong><strong>const transactionIndex = new anchor.BN(multisigAccount.transactionIndex + 1);
</strong><strong>
</strong><strong>// get the transaction PDA
</strong><strong>const transaction = await anchor.web3.PublicKey.findProgramAddress(
</strong>    anchor.utils.bytes.utf8.encode("squad"),
    multisig.toBuffer(),
    transactionIndex.toBuffer("le", 4), // or .toArrayLike(Buffer, "le", 4) 
    anchor.utils.bytes.utf8.encode("transaction")
<strong>);
</strong><strong>
</strong><strong>// get the public key of the payer/creator
</strong><strong>const creator = wallet.publicKey;
</strong><strong>
</strong><strong>await program.methods.createTransaction(1) //using authorityIndex of 1
</strong>   .accounts({
       multisig,    // the multisig PDA
       transaction, // the transaction PDA
       creator // the creator/payer of the transaction acccount
    })
    .rpc();
</code></pre>

After being created, the transaction will remain in a `Draft` status, until it is activated by the member key that created it.

Refer to the [Transaction PDA section](/squads-v3-docs/development/pdas/transaction.md) for more information about deriving the transaction PDA and [the Authority section](/squads-v3-docs/development/authorities.md) for information about how authorities function within Squads.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.squads.so/squads-v3-docs/development/anchor-idl/transactions/create-a-transaction.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
